(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["logscribe"] = factory();
	else
		root["logscribe"] = factory();
})(global, function() {
return /******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ 607:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.logscribe = exports.setPrintDisabled = exports.setLogPrefix = exports.setLogMaxSize = exports.setLogDirPath = exports.lp = exports.logprint = exports.p = exports.print = exports.l = exports.log = exports.getTagForLog = exports.getTagForPrint = void 0;
var fs = __webpack_require__(747);
var path = __webpack_require__(622);
// Testing environment doesn't understand require.main and such.
var isTesting = "production" === 'testing';
if (!isTesting) {
    __webpack_require__.c[__webpack_require__.s] = process.mainModule;
}
// AppDir holds directory path to the application's root.
var appDir = isTesting
    ? path.resolve(__dirname)
    : path.dirname( true && __webpack_require__.c[__webpack_require__.s] ? __webpack_require__.c[__webpack_require__.s].filename : '');
// Here we will store ids of async Promises so that the logging will happen in order.
// Prioritize the user's application 1st!
var buffer = [];
var dateBuffer = [];
// Settings -------------------------------------------------------------------
// These are the so called global settings.
// User can modify these on file-basis.
var settings = {
    logDirPath: appDir,
    logMaxSize: 1024000,
    logPrefix: 'application',
    printDisabled: false,
    printTagColor: '\x1b[36m',
};
// Used to search for existing log files.
var regExp = new RegExp("^" + settings.logPrefix + "_.*log", 'g');
// LogScribe utility methods --------------------------------------------------
/**
 * Returns a tag that is suitable for printting.
 * @param {string} tag - A tag to be printed.
 * @param {color} color - Color of the tag text.
 * @returns {string} - A formatted tag.
 */
var getTagForPrint = function (tag, color) {
    try {
        return "" + (color || settings.printTagColor) + tag + "\u001B[0m -";
    }
    catch (_a) {
        return ' -';
    }
};
exports.getTagForPrint = getTagForPrint;
/**
 * Returns a tag that is suitable for logging.
 * @param {string} tag - A tag to be logged.
 * @returns {string} - A formatted tag.
 */
var getTagForLog = function (tag) {
    try {
        return typeof tag === 'string' && tag !== '' ? "[" + tag + "]" : '[]';
    }
    catch (_a) {
        return '[]';
    }
};
exports.getTagForLog = getTagForLog;
/**
 * Does the actual log writing.
 * Writes everything in buffer to log files and then clears the buffer.
 */
var writeBufferToLog = function (files, index, existingPath) {
    try {
        // We can't combine finding with executeBuffer() at it may be that the
        // previous entry in buffer was humongous and the size is now fulfilled.
        var filepath_1 = '';
        if (existingPath) {
            // We already have a suitable filepath.
            filepath_1 = existingPath;
        }
        else {
            filepath_1 =
                settings.logDirPath + "\\" + settings.logPrefix + "_" +
                    (dateBuffer[index].getFullYear() + "-") +
                    (dateBuffer[index].getMonth() + "-") +
                    (dateBuffer[index].getDate() + "-") +
                    (dateBuffer[index].getTime() + ".log");
        }
        fs.appendFile(filepath_1, buffer[index], 'utf8', function (aErr) {
            if (aErr) {
                // Something went wrong, clear the buffer to start fresh
                // next time.
                buffer = [];
                dateBuffer = [];
            }
            else if (buffer[index + 1]) {
                // We measure the file size after the addition
                // to determine whether this same file can be re-used
                // for the next buffer entry. This should save us some cycles.
                fs.stat(filepath_1, function (err, stat) {
                    if (err) {
                        buffer = [];
                        dateBuffer = [];
                    }
                    else if (stat.size < settings.logMaxSize) {
                        // We skip executeBuffer to save performance.
                        // In theory some of the files may have gotten deleted,
                        // but that should be super rare as the buffer clears so fast and
                        // no-one else should be removing our log files after all.
                        writeBufferToLog(files, index + 1, filepath_1);
                    }
                    else {
                        writeBufferToLog(files, index + 1);
                    }
                });
            }
            else {
                // Buffer is executed, clear it.
                buffer = [];
                dateBuffer = [];
            }
        });
        return;
    }
    catch (_a) {
        return;
    }
};
/**
 * Starts to executing the buffer.
 * Buffer contains all the log messages that need to be logged.
 *
 * We shall gather all suitable log files here before we start,
 * this way we don't have to sacrifice performance on finding
 * files on each buffer index.
 */
var executeBuffer = function () {
    fs.readdir(settings.logDirPath, function (err, items) {
        if (err) {
            // Something went wrong, clear the buffer to start fresh
            // next time.
            buffer = [];
            dateBuffer = [];
        }
        else if (items[0]) {
            var files_1 = items.filter(function (f) { return regExp.test(f); });
            if (files_1[0]) {
                var findStat_1 = function (i) {
                    var f = settings.logDirPath + "\\" + files_1[i];
                    fs.stat(f, function (errStat, stat) {
                        if (errStat) {
                            // Something went wrong.
                            buffer = [];
                            dateBuffer = [];
                        }
                        else if (stat.size < settings.logMaxSize) {
                            // Bling! A suitable file was found.
                            writeBufferToLog(files_1, 0, f);
                        }
                        else if (files_1[i + 1]) {
                            // Read more stats.
                            findStat_1(i + 1);
                        }
                        else {
                            // A new path must be created.
                            writeBufferToLog(files_1, 0);
                        }
                    });
                };
                findStat_1(0);
            }
            else {
                // No existing log files.
                writeBufferToLog([], 0);
            }
        }
        else {
            // Empty dir.
            writeBufferToLog([], 0);
        }
    });
};
// LogScribe public methods ---------------------------------------------------
/**
 * Logs text to a log file.
 * @param payload - A message to log.
 * @returns {Promise<string>} - A message that was saved.
 */
var log = function () {
    var payload = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        payload[_i] = arguments[_i];
    }
    try {
        var m_1 = '';
        // Combine the message. Remember, join() would be heavy.
        payload.forEach(function (v) { return (m_1 += v + "\n"); });
        if (!buffer[0]) {
            dateBuffer.push(new Date());
            buffer.push(dateBuffer[0] + "\n" + m_1 + "\n");
            executeBuffer();
        }
        else {
            var d = new Date();
            dateBuffer.push(d);
            buffer.push(d + "\n" + m_1 + "\n");
        }
    }
    catch (_a) {
        return;
    }
};
exports.log = log;
// Alias to log().
exports.l = exports.log;
/**
 * Prints text to console.
 * @param payload - A message to print.
 */
var print = function () {
    var payload = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        payload[_i] = arguments[_i];
    }
    try {
        if (settings.printDisabled) {
            // If printing is disabled, don't print.
            return;
        }
        var d = new Date();
        console.log.apply(console, __spreadArray([('0' + d.getHours()).slice(-2) + ":" +
                (('0' + d.getMinutes()).slice(-2) + ":") +
                ("" + ('0' + d.getSeconds()).slice(-2))], payload));
    }
    catch (_a) {
        return;
    }
};
exports.print = print;
// Alias to print().
exports.p = exports.print;
/**
 * Logs and prints a message.
 * A combination of log() and print().
 * @param payload - A message to print and log.
 */
var logprint = function () {
    var payload = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        payload[_i] = arguments[_i];
    }
    try {
        exports.print.apply(void 0, payload);
        exports.log.apply(void 0, payload);
    }
    catch (_a) {
        return;
    }
};
exports.logprint = logprint;
// Alias to logprint();
exports.lp = exports.logprint;
// LogScribe private methods --------------------------------------------------
/**
 * Used to enable logprint with a tag.
 * @param tag - A tag to be printed.
 * @param payload - A message to print and log.
 */
var logprintWithTag = function (tag) {
    var payload = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        payload[_i - 1] = arguments[_i];
    }
    try {
        exports.print.apply(void 0, __spreadArray([exports.getTagForPrint(tag)], payload));
        exports.log.apply(void 0, __spreadArray([exports.getTagForLog(tag)], payload));
    }
    catch (_a) {
        return;
    }
};
/**
 * Sets default directory path for the log files.
 * @param {string} value - A new value to be saved.
 */
var setLogDirPath = function (value) {
    try {
        settings.logDirPath = String(value);
    }
    catch (_a) {
        return;
    }
};
exports.setLogDirPath = setLogDirPath;
/**
 * Sets maximum size for the log files (1000 = 1KB).
 * @param {string} value - A new value to be saved.
 */
var setLogMaxSize = function (value) {
    try {
        settings.logMaxSize = Number(value);
    }
    catch (_a) {
        return;
    }
};
exports.setLogMaxSize = setLogMaxSize;
/**
 * Sets prefix for the log files (e.g. application_).
 * @param {string} value - A new value to be saved.
 */
var setLogPrefix = function (value) {
    try {
        settings.logPrefix = String(value);
        regExp = new RegExp("^" + settings.logPrefix + "_.*log", 'g');
    }
    catch (_a) {
        return;
    }
};
exports.setLogPrefix = setLogPrefix;
/**
 * Disables printing.
 * @param {string} value - A new value to be saved.
 */
var setPrintDisabled = function (value) {
    try {
        settings.printDisabled = Boolean(value);
    }
    catch (_a) {
        return;
    }
};
exports.setPrintDisabled = setPrintDisabled;
/**
 * Returns everything this module has to provide but with a
 * global tag attached.
 * @param tag - A tag to be logged.
 * @param color A tag color to be used, e.g. "\x1b[36m".
 */
var logscribe = function (tag, color) {
    return {
        l: function () {
            var payload = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                payload[_i] = arguments[_i];
            }
            return exports.log.apply(void 0, __spreadArray([exports.getTagForLog(tag)], payload));
        },
        log: function () {
            var payload = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                payload[_i] = arguments[_i];
            }
            return exports.log.apply(void 0, __spreadArray([exports.getTagForLog(tag)], payload));
        },
        logprint: function () {
            var payload = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                payload[_i] = arguments[_i];
            }
            return logprintWithTag.apply(void 0, __spreadArray([tag], payload));
        },
        lp: function () {
            var payload = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                payload[_i] = arguments[_i];
            }
            return logprintWithTag.apply(void 0, __spreadArray([tag], payload));
        },
        p: function () {
            var payload = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                payload[_i] = arguments[_i];
            }
            return exports.print.apply(void 0, __spreadArray([exports.getTagForPrint(tag, color)], payload));
        },
        print: function () {
            var payload = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                payload[_i] = arguments[_i];
            }
            return exports.print.apply(void 0, __spreadArray([exports.getTagForPrint(tag, color)], payload));
        },
    };
};
exports.logscribe = logscribe;
exports.default = exports.logscribe;


/***/ }),

/***/ 747:
/***/ ((module) => {

module.exports = require("fs");;

/***/ }),

/***/ 622:
/***/ ((module) => {

module.exports = require("path");;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = __webpack_module_cache__;
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// module cache are used so entry inlining is disabled
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	var __webpack_exports__ = __webpack_require__(__webpack_require__.s = 607);
/******/ 	
/******/ 	return __webpack_exports__;
/******/ })()
;
});